#include <iostream>

class Base {
   public:
      Base(int capacity) {
         std::cout << "Base::Base -- allocate data" << std::endl;
         data = new int[capacity];
      }
      virtual ~Base() {
         std::cout << "Base::~Base -- release data" << std::endl;
         delete[] data;
      }
   protected:
      int *data;
};

class Derived : public Base {
   public:
      Derived(int capacity) : Base(capacity) {
         std::cout << "Derived::Derived -- allocate data2" << std::endl;
         data2 = new int[capacity];
      }
      ~Derived() {
         std::cout << "Derived::~Derived -- release data2" << std::endl;
         delete[] data2;
      }
   protected:
      int *data2;
};

int main(void)
{
   { 
      std::cout << "Using Derived " << std::endl;
      Derived *object = new Derived(1000000);
      delete object;
      std::cout << std::endl;
   }
   {
      std::cout << "Using Base" << std::endl;
      Base *object = new Derived(1000000);
      delete object;
   }
   { // without dynamic call
      std::cout << "Using Derived " << std::endl;
      Derived object(1000000);
      std::cout << std::endl;
   }
   {
      std::cout << "Using Base" << std::endl;
      Base object(1000000);
   }

   return 0;
}
